package de.hdm_stuttgart.mi.sda1;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import de.hdm_stuttgart.mi.sda1.model.StudyCourse;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

/**
 * Create a transient {@link StudyCourse} instance and persist it to the database.
 */
public class CreateStudyCourse {

  static private final Logger log = LogManager.getLogger(CreateStudyCourse.class);

  static private final EntityManagerFactory factory =
    Persistence.createEntityManagerFactory("strategy_drop-and-create");

  static private final EntityManager entityManager = factory.createEntityManager();

  /**
   * @param args Unused
   */
  public static void main( String[] args ) {

    final EntityTransaction tx = entityManager.getTransaction();

    final StudyCourse csm = new StudyCourse(
        "CSM", "Computer Science and Media");

    log.info(csm);
    tx.begin();
      entityManager.persist(csm);
    tx.commit();
    log.info(csm);


    // See http://stackoverflow.com/questions/21645516/program-using-hibernate-does-not-terminate
    factory.close();
  }
}