package de.hdm_stuttgart.mi.sda1;

import de.hdm_stuttgart.mi.sda1.model.Student;
import de.hdm_stuttgart.mi.sda1.model.StudyCourse;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import java.util.List;
import java.util.Vector;

/**
 * Persist multiple {@link StudyCourse} instances.
 */
public class CreateUniversity {

  static private final Logger log = LogManager.getLogger(CreateUniversity.class);

  static private final EntityManagerFactory factory =
    Persistence.createEntityManagerFactory("strategy_drop-and-create");

  static private final EntityManager entityManager = factory.createEntityManager();

  /**
   * @param args Unused
   */
  public static void main( String[] args ) {

    final List<StudyCourse> studyCourses = new Vector<>();
    studyCourses.add(new StudyCourse("CSM", "Computer Science and Media"));
    studyCourses.add(new StudyCourse("MMB", "Mobile Media"));
    studyCourses.add(new StudyCourse("CRB", "Cross Media Journalism"));
    studyCourses.add(new StudyCourse("IDB", "Information Design"));

    final EntityTransaction tx = entityManager.getTransaction();
    tx.begin();
      studyCourses.forEach(entityManager::persist);
    tx.commit();
    log.info( studyCourses.size() + " study courses persisted");

    final List<Student> students = new Vector<>();
    students.add(new Student("Jill Evans"));
    students.add(new Student("Peter Brown"));

    StudyCourse csm = studyCourses.get(0);
    tx.begin();
      students.forEach(s -> s.enroll(csm));
    tx.commit();

    // See http://stackoverflow.com/questions/21645516/program-using-hibernate-does-not-terminate
    factory.close();
  }
}