package de.hdm_stuttgart.mi.sda1.jdom.background;

import java.io.IOException;
import java.util.List;

import de.hdm_stuttgart.mi.unitmarking.jdom.DomFilter;
import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.JDOMException;
import org.jdom2.xpath.XPathExpression;
import org.jdom2.xpath.XPathFactory;

/**
 * Address book data.
 *
 */
public class TableRowColumnSwitch implements DomFilter {
  /**
   * Reading XML input an create corresponding HTML output
   * @param addressbook XML input data
   * @throws JDOMException Internal errors
   * @throws IOException IO related errors.
   */
   @Override
   public Document process(Document addressbook) {

		final Element table = new Element("table");

		// Search for <person> elements
		@SuppressWarnings({ "unchecked", "rawtypes" })
		final XPathExpression<Element> xpath = (XPathExpression<Element>) (XPathExpression) XPathFactory
				.instance().compile("/addressbook/person");
		final List<Element> persons = xpath.evaluate(addressbook);
		
		// Create the <tr> row of names.
		final Element nameRow = new Element("tr");
		table.addContent(nameRow);
		nameRow.addContent(new Element("th").addContent("Name"));

		// Create the <tr> row of birthdays.
		final Element birthdayRow = new Element("tr");
		table.addContent(birthdayRow);
		birthdayRow.addContent(new Element("th").addContent("Birthday"));

		for (Element person : persons) {
			nameRow.addContent(new Element("td").addContent(person.getChild("name").getText()));
			birthdayRow.addContent(new Element("td").addContent(person.getChild("birthday").getText()));
		}
		return new Document(table);
   }
}