package de.hdm_stuttgart.mi.sda1.saxhtml.v1;

import java.io.PrintStream;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import de.hdm_stuttgart.mi.exam.SaxFilter;

/**
 * Turning &lt;memo&gt; documents to HTML
 *
 */
public class Memo2HtmlHandler extends DefaultHandler implements SaxFilter {

	private PrintStream out;

   /**
    * Output will be written to stdout
    */
   public Memo2HtmlHandler() {
      setOutputStream(System.out);
   }

	boolean printCharacters = false;

	@Override
	public void startDocument() throws SAXException {

		out.print("<html>" + "\n  <head>" + "\n    <title>Memo message</title>"
				+ "\n  </head>" + "\n  <body>");
	}

	@Override
	public void startElement(String uri, String localName, String tagName,
			Attributes attributes) throws SAXException {
		switch (tagName) {
		case "from":
			out.print("\n    <h2>Message from <strong>");
			printCharacters = true;
			break;

		case "to":
			printCharacters = true;
			out.print("      <li>");
			break;

		case "subject":
			printCharacters = true;
			out.print("    </ul>" + "\n    <h2>Subject: ");
			break;

		case "content":
			printCharacters = true;
			out.print("\n    <p>");
			break;
		}
	}

	@Override
	public void characters(char[] ch, int start, int length)
			throws SAXException {
		if (printCharacters) {
			out.print(new String(ch, start, length));
		}
	}

	@Override
	public void endElement(String uri, String localName, String tagName)
			throws SAXException {
		printCharacters = false;
		switch (tagName) {

		case "from":
			out.println("</strong></h2>" + "\n    <h2>Recipients:</h2>"
					+ "\n    <ul>");
			break;

		case "to":
			out.println("</li>");
			break;

		case "subject":
			out.print("</h2>");
			break;

		case "content":
			out.print("</p>");
			break;
		}
	}

	@Override
	public void endDocument() throws SAXException {
		out.println("\n  </body>" + "\n</html>");
		out.flush();
	}

   @Override
   public void setOutputStream(final PrintStream out) {
      this.out = out;
   }
}