<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    version="2.0">
    
    <xsl:output method="xml" indent="yes"/>
    
    <xsl:template match="/persons">
        <users xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
            xsi:noNamespaceSchemaLocation="user.xsd" 
            >
            <xsl:apply-templates select="person[@id]"/> <!-- Selecting only <person> nodes having an @id attribute -->
        </users>
    </xsl:template>
    
    <xsl:template match="person[@id]"> <!-- <person> elements without @id attribute cannot show up -->
        <user index="{position()}" uid="user_{@id}">
            <uid>
                <xsl:value-of select="lastName"/>
            </uid>
            <fullName>
                <xsl:value-of select="firstName"/>
                <xsl:text> </xsl:text>
                <xsl:value-of select="lastName"/>
            </fullName>
            <contact>
                <xsl:choose> <!-- <xsl:choose> acts like if(...) ... else if(...) ... else {} -->
                    <xsl:when test="email">
                        <!--<xsl:attribute ...> acts on the nearest non-XSL ancestor element (<contact>) -->
                        <xsl:attribute name="type" select="'email'"/>
                        <xsl:value-of select="email"/>
                    </xsl:when>
                    <xsl:when test="phone">
                        <xsl:attribute name="type" select="'phone'"/>
                        <xsl:value-of select="phone"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:attribute name="type" select="'none'"/>
                    </xsl:otherwise>
                </xsl:choose>
            </contact>
        </user>
    </xsl:template>

</xsl:stylesheet>