package de.hdm_stuttgart.sw1.klausur.angebot;

/**
 * <p>Verzinsung von Guthaben oder Schulden. Es gelten folgende Regeln:</p>
 * 
 * <p>Einmal pro Jahr kann über eine der beiden Methoden  {@link #neuesJahr(double, double, double)} oder {@link #neuesJahr(double)}
 *   gemäß Vorzeichen des Betrags eingezahlt oder abgehoben werden.</p>
 *   
 * <p>Gleichzeitig können zu diesem Zeitpunkt die Zinssätze für Guthaben und Schulden (Soll) für das Folgejahr angepasst werden.</p>
 * 
 */
public class Konto {
   
   /**
    * Erstelle neues Konto.
    * 
    * @param kontostand Initialer Kontostand.
    * @param guthabenZins Initialer Guthabenzins.
    * @param sollZins Initialer Schuldzins.  
    */
   public Konto(double kontostand, double guthabenZins, double sollZins) {
      // TODO: Implementiere mich richtig.
   }
   
   /**
    * <p>Diese oder alternativ die Methode {@link #neuesJahr(double)} wird einmal
    * jährlich ausgeführt.</p>
    * 
    * <p>Die Methode bewirkt folgende Änderungen:</p>
    * 
    * <ul>
    *   <li>Durchführung der Verzinsung für das zurückliegende Jahr zu aktuellen Guthaben- bzw. Schuldzinsen.</li>
    *   <li>Einzahlung für das jeweils nächste Jahr</li>
    *   <li>Anpassung von Guthaben- und Schuldzins für das kommende Verzinsungsjahr.</li>
    * </ul>
    * 
    * @param betrag Je nach Vorzeichen neu hinzugefügter oder abgebuchter Betrag. 
    * @param guthabenZins Der für das jeweils kommende Jahr geltende prozentuale Guthabenzins für nichtnegative Kontostände. 
    * @param sollZins Der für das jeweils kommende Jahr geltende prozentuale Guthabenzins für negative Kontostände.
    * 
    * <p style="color: red;font-weight: bold;">Tip: Im Hinblick auf das Journal in {@link #getJournal()} können Sie alle
    * benötigten Informationen in einer {@link StringBuffer} Instanzvariablen sammeln. Sinngemäß gilt dies auch für den jeweils
    * aktuellen Kontostand.</p>
    */
   public void neuesJahr(double betrag, double guthabenZins, double sollZins) {
      // TODO: Implementiere mich richtig.   
      }

   /**
    * Wie {@link #neuesJahr(double, double, double)} allerdings ohne Änderung von Guthaben- und Sollzins für
    * das kommende Verzinsungsjahr.
    *  
    * @param betrag Je nach Vorzeichen neu hinzugefügter oder abgebuchter Betrag. 
    */
   public void neuesJahr(double betrag) {
      // TODO: Implementiere mich richtig.   
      }
   
   /**
    * @return Der aktuelle Kontostand.
    */
   public double getKontostand() {
      return -323.43; // TODO: Implementiere mich richtig.
   }
   
   /**
    * Die Entwicklung der Kontostände kaufmännisch auf ganzzahlige Werte gerundet. Für das Beispiel {@link DummyZinsen#main(String[])} ergibt sich:
    * 
    * <pre>Jahr 0, Kontostand=100, verzinsung=1.0%
    *Jahr 1, Kontostand=201, verzinsung=1.0%
    *Jahr 2, Kontostand=403, verzinsung=2.0%
    *Jahr 3, Kontostand=-89, verzinsung=-8.0%</pre>
    * 
    * @return Ausdruckbarer Verlauf der Kontoentwicklung
    * 
    * <ul>
    *   <li><p style="color: red;font-weight: bold;">Tip: Im Hinblick auf das Journal in {@link #getJournal()} können Sie alle
    * benötigten Informationen in einer {@link StringBuffer} Instanzvariablen sammeln. Sinngemäß gilt dies auch für den jeweils
    * aktuellen Kontostand. Beachten Sie die Methode {@link Math#round(double)}</p></li>
    * 
    * <li><p style="color: red;font-weight: bold;">Tip: Ein Hang zum Erbsenzählen erleichtert die Lösung.
    * Bereits ein falsches Leer- oder fehlendes Newline Zeichen (auch am Ende!)
    * lässt die zugehörigen Tests scheitern. Beachten Sie allfällige Junit Fehlermeldungen sehr genau.</p></li>
    * 
    * </ul>
    * 
    */
   public String getJournal() {
      return "dxas"; // TODO: Implementiere mich richtig.
   }
}