package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe1.Differenzen;

/**
 * <p>Testen von {@link Differenzen#getDifferenzBetraege(int, int, int)}
 *  und {@link Differenzen#getDifferenzBetraege(int[])}.
 *
 */
@SuppressWarnings({"static-method"})
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_Differenzen extends ExaminationTestDefaults {
   
   /**
    * Positive Betragsdifferenz
    */
   @Test
   @Marking(points=3)
   public void test_100_positiveBetragsdifferenz() {
      Assert.assertEquals(
            9,                           //4  +5
            Differenzen.getDifferenzBetraege(1, 5, 10));
   }
   /**
    * Gemischte Betragsdifferenz
    */
   @Test
   @Marking(points=3)
   public void test_110_gemischteBetragsdifferenz() {
      // |-1 - 4| + |3 - (-1)| == 5 + 4 == 9
      Assert.assertEquals(
            9,                           // 5 +4
            Differenzen.getDifferenzBetraege(4, -1, 3));
   }
   
   /**
    * Sonderfall identischer Werte
    */
   @Test
   public void test_130_identischeWerte() {
      Assert.assertEquals(
            0,                            // 0  +0
            Differenzen.getDifferenzBetraege(-5, -5, -5));
   }
   
   /**
    * Betragsdifferenz positiver Werte. 
    */
   @Test
   @Marking(points=2)
   public void test_200_positiveWerte() {
      Assert.assertEquals(
            12,                                   // 4 +3 +5
            Differenzen.getDifferenzBetraege(new int[]{1, 5, 2, 7}));
   }
   
   /**
    * Betragsdifferenz gemischter Werte. 
    */
   @Test
   @Marking(points=2)
   public void test_210_gemischteWerte() {
      
      Assert.assertEquals(
            48,                                    // 6 +7 + 9+15 +11
            Differenzen.getDifferenzBetraege(new int[]{1, -5, 2, -7, 8, -3}));
   }
   
   /**
    * Sonderfall null. 
    */
   @Test
   @Marking(points=2)
   public void test_220_null() {
      
      Assert.assertEquals(
            0,
            Differenzen.getDifferenzBetraege(null));
   }
   
   /**
    * Sonderfall Arraylänge kleiner 2. 
    */
   @Test
   @Marking(points=2)
   public void test_230_laengeKleinerZwei() {
      Assert.assertEquals(0, Differenzen.getDifferenzBetraege(new int[]{}));
      Assert.assertEquals(0, Differenzen.getDifferenzBetraege(new int[]{-14}));
   }
}