package de.hdm_stuttgart.mi.sd1.aufgabe1;

/**
 * <p>Betragsdifferenzen von Zahlenfolgen.</p>
 *
 */
public class Differenzen {
   /**
    * <p>Summe der beiden Betragsdifferenzen von ersten und zweitem
    *   bzw. zweitem und drittem Wert.</p>
    * 
    * <p>Beispiele</p>
    * 
    * <ul>
    *   <li> (1,  3, 7), dann ist 3-1 == 2 und 7-3 == 4, ergebnis == 2 + 4, also 6</li>
    *   <li> (2, -3, 5), dann ist -3-2 == -5 und 5-(-3)==8, ergebnis == |-5| + 8, also 13.</li>
    * </ul>
    * 
    * @param a Erster Wert
    * @param b Zweiter Wert
    * @param c Dritter Wert
    * @return |b - a| + |c - b|
    */
   static public int getDifferenzBetraege (int a, int b, int c) {
      return Math.abs(b - a) + Math.abs(c - b);
   }
   
   /**
    * <p>Summe der Betragsdifferenzen eines Arrays aus Ganzzahlen analog zu 
    *   {@link #getDifferenzBetraege(int, int, int)}.</p>
    * 
    * <p>Beispiel:</p>
    * 
    * <p>werte == {1, 5, 2, 7}, dann haben wir das Ergebnis zu |5 - 1| + |2 - 5| + |7 - 2| == 4 + 3 + 5 == 12</p>
    * 
    * @param werte Ein Array aus Ganzzahlen oder null
    * @return <ul>
    *               <li>0, falls null == werte oder werte.length &lt; 2 gilt</li>  
    *               <li>Die Summe der Betragsdifferenzen analog zu {@link #getDifferenzBetraege(int, int, int)}</li>  
    *            </ul>
    */
   static public int getDifferenzBetraege (int[] werte) {
      if (null == werte || werte.length < 2) {
         return 0;
      } else {
         int summe = 0;
         for (int i = 1; i < werte.length; i++) {
            summe += Math.abs(werte[i] - werte[i - 1]);
         }
         return summe;
      }
   }
}