package de.hdm_stuttgart.mi.sd1.aufgabe1;

/**
 * Stehen zwei Ganzzahlen in der Beziehung »ist Vielfaches von« ?
 */
public class Vielfache {
   /**
    * <p>Ist <code>a</code> ein <strong>echtes</strong> Vielfaches von <code>b</code>?</p>
    * 
    * <p>Definition: Für zwei vorzeichenbehaftete Ganzzahlen a und b
    *    gilt: a ist ein <strong>echtes</strong> Vielfaches von b,
    *    wenn es eine Ganzzahl k mit Betrag echt größer 1 gibt,
    *    so dass a = k * b gilt.</p>
    * 
    * <p>Beispiele:</p>
    * 
    * <ul>
    *   <li>6 ist echtes Vielfaches von 3 (k == 2)</li>
    *   <li>-10 ist echtes Vielfaches von 2 (k == -5, Betrag 5 )</li>
    *   <li>5 ist kein Vielfaches von 3</li>
    *   <li>3 ist kein echtes Vielfaches von 3 (k == 1, Betrag nicht größer 1)</li>
    *   <li>2 ist kein echtes Vielfaches von -2 (k == -1, Betrag nicht größer 1)</li>
    *   <li>0 ist echtes Vielfaches von 0 (k mit Betrag größer 1 beliebig wählbar)</li>
    *   <li>0 ist kein echtes Vielfaches von Ganzzahlen ungleich 0 (k == 0, Betrag nicht größer 1)</li>
    * </ul>
    * 
    * @param a Ist dieser Wert gleich k * b mit 1 &lt; |k| ?
    * @param b Gibt es ein k mit 1 &lt; |k| so dass k * b den Wert von
    *         a ergibt?
    * @return <code>true</code> genau dann, wenn entweder
    *         <code>a</code> ein Vielfaches von <code>b</code> oder
    *         umgekehrt <code>b</code> ein Vielfaches von
    *         <code>a</code> ist. Ansonsten <code>false</code>.
    *               
    * <p style="color: red;font-weight: bold;">Tip: Beachten den
    *    »%«Operator zur Restbildung.</p>
    */
   static public boolean istEchtesVielfachesVon(final int a, final int b) {
      // Tip: Beachten Sie den % Operator zur Restbildung
      
      if (0 == b) {
         return a == 0; 
      } else {
         return 0 == a % b && 1 < Math.abs(a / b);
      }
   }
}