package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.sd1.aufgabe1.FitnessTarifRechner;

/**
 * <p>Kostenrechner Fitnessstudio.</p>
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_FitnessTarifRechner extends ExaminationTestDefaults {

  /**
   * Kosten ohne Tarifbindung
   */
  @Test public void test_200() {
    Assert.assertEquals(0, FitnessTarifRechner.getKostenOhneTarif((short) 0));
  }
  @Test @Marking(points = 2) public void test_220() {
    Assert.assertEquals(1020, FitnessTarifRechner.getKostenOhneTarif((short) 85));
  }
  @Test @Marking(points = 2) public void test_240() {
    Assert.assertEquals(0, FitnessTarifRechner.getKostenOhneTarif((short) -13));
  }

  /**
   * Kosten im Flextarif
   */
  @Test public void test_260() {
    Assert.assertEquals(FitnessTarifRechner.basiskostenFlextarif, FitnessTarifRechner.getKostenFlextarif((short) 0));
  }
  @Test public void test_280() {
    Assert.assertEquals(260, FitnessTarifRechner.getKostenFlextarif((short) 22));
    Assert.assertEquals(655, FitnessTarifRechner.getKostenFlextarif((short) 101));
  }
  @Test public void test_300() {
    Assert.assertEquals(FitnessTarifRechner.basiskostenFlextarif, FitnessTarifRechner.getKostenFlextarif((short) -14));
  }

  // Abschnitt optimale Tarifbestimmung.

  /**
   * Höchste Besuchszahl, bei welcher sich kein Tarifabschluss lohnt.
   */
  @Test
  public void test_400() {
    Assert.assertEquals(FitnessTarifRechner.TARIFTYP_PRO_BESUCH, FitnessTarifRechner.getOptimalenTariftyp((short) 21));
  }
  /**
   * Niedrigste Besuchszahl, bei welcher sich der Flextarif lohnt.
   */
  @Test
  public void test_420() {
    Assert.assertEquals(FitnessTarifRechner.TARIFTYP_FLEX, FitnessTarifRechner.getOptimalenTariftyp((short) 22));
  }
  /**
   * Grenztest: 800€ sowohl für Flex- als auch Ganzjahrestarif.
   */
  @Test public void test_480() {
    Assert.assertEquals(FitnessTarifRechner.TARIFTYP_FLEX, FitnessTarifRechner.getOptimalenTariftyp((short) 130));
  }
  /**
   * Grenztest: 800€ sowohl für Flex- als auch Ganzjahrestarif.
   */
  @Test public void test_500() {
    Assert.assertEquals(FitnessTarifRechner.TARIFTYP_JAHRESVORAUSZAHLUNG, FitnessTarifRechner.getOptimalenTariftyp((short) 131));
  }
}