package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe1.ArrayHelper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_ArrayHelper extends ExaminationTestDefaults {

  // Teste int[] Parameter
  @Test public void test_380_testNull() {
    Assert.assertFalse(ArrayHelper.enthaeltDuplikate((int[]) null));
    Assert.assertTrue(ArrayHelper.enthaeltDuplikate(new int[]{1, 1}));
  }
  @Test public void test_400_testKeinDuplikat_0() {
    Assert.assertFalse(ArrayHelper.enthaeltDuplikate(new int[]{0}));
    Assert.assertTrue(ArrayHelper.enthaeltDuplikate(new int[]{1, 1}));
  }
  @Test @Marking(points = 3) public void test_410_testKeinDuplikat_1() {
    Assert.assertFalse(ArrayHelper.enthaeltDuplikate(new int[]{1}));
    Assert.assertTrue(ArrayHelper.enthaeltDuplikate(new int[]{1, 4, 1}));
  }
  @Test @Marking(points = 2) public void test_420_testKeinDuplikat_2() {
    Assert.assertFalse(ArrayHelper.enthaeltDuplikate(new int[]{-1, 2}));
    Assert.assertTrue(ArrayHelper.enthaeltDuplikate(new int[]{1, 4, 4}));
  }

  @Test @Marking(points = 2) public void test_430_testKeinDuplikat_6() {
    Assert.assertFalse(ArrayHelper.enthaeltDuplikate(new int[]{-1, 2, 5, 9, -30, 0}));
    Assert.assertTrue(ArrayHelper.enthaeltDuplikate(new int[]{2, 4, 3, 0, 1, 2}));
  }
  @Test @Marking(points = 2) public void test_440_testNull() {
    Assert.assertFalse(ArrayHelper.enthaeltDuplikate((int[]) null));
    Assert.assertTrue(ArrayHelper.enthaeltDuplikate(new int[]{0, 0}));
  }

  // Teste Object[] parameter
  @Test @Marking(points = 2) public void test_500_string_testNull() {
    Assert.assertFalse(ArrayHelper.enthaeltDuplikate((String[]) null));
    Assert.assertTrue(ArrayHelper.enthaeltDuplikate(new String[]{
            new String("ab"), "ab"}));
  }

  @Test @Marking(points = 2) public void test_520_string_testNullEnthalten() {
    Assert.assertTrue(ArrayHelper.enthaeltDuplikate(new String[]{
        new String("ab"), null, "ab"}));
    Assert.assertFalse(ArrayHelper.enthaeltDuplikate(new String[]{null, null, null}));
  }

  @Test @Marking(points = 2) public void test_530_string_testHeterogen() {
    Assert.assertFalse(ArrayHelper.enthaeltDuplikate(new Object[]{"test", new StringBuffer("test")}));
    Assert.assertTrue(ArrayHelper.enthaeltDuplikate(new Object[]{new String("test"), new String("test")}));
  }
}