package de.hdm_stuttgart.mi.sd1.aufgabe1;


/**
 * Spezielle Berechnungsmethoden.
 */
public class MathHelper {

  static private int wertFallsUngerade(int wert) {
    if (0 == wert % 2) {
      return 0;
    } else {
      return wert;
    }
  }
  /**
   * <p>Die Summe aller ungeraden Werte zweier Argumente. Gerade Werte werden
   * bei der Summenbildung ignoriert. Beispiele:</p>
   *
   * <ul>
   *   <li>summeUngeraderWerte(3, 4) ergibt 3, weil 4 als gerader Wert ignoriert wird.</li>
   *   <li>summeUngeraderWerte(1, 5) ergibt 1 + 5 == 6, da beide Werte ungerade sind.</li>
   *   <li>summeUngeraderWerte(-4, 10) ergibt 0, weil beide Werte gerade sind und somit ignoriert werden.</li>
   *
   * </ul>
   *
   * @param a Erster Wert.
   * @param b Zweiter Wert
   * @return Die Summe aller ungeraden Werte beider Argumente.
   */
  static public int summeUngeraderWerte(final int a, final int b) {
    /*
          Tip: Der »%« Operator ist Ihr Freund!
     */

    return wertFallsUngerade(a) + wertFallsUngerade(b);
  }
  /**
   * <p>Die harmonische Reihe H(n) zu einer natürlichen Zahl 0 &lt; n ist definiert als:</p>
   *
   * <p>H(n) = 1/1 + 1/2 + 1/3 + ... + 1/n</p>
   *
   * <p>Also beispielsweise:</p>
   * <ul>
   *   <li>H(2) = 1 + 1/2 = 1 + 0.5 = 1.5</li>
   *   <li>H(3) = 1 + 1/2 + 1/3 = 11/6 = 1.8333333...</li>
   * </ul>
   *
   * @param n Anzahl der Terme der harmonischen Reihe, mindestens 1.
   * @return Der Wert H(n).
   */
  static public double harmonisch(final int n) {
    /*
        Tip: Beachten Sie mögliche Probleme bei der Division zweier int Werte.
     */
    double summe = 1;
    for (int i = 2; i <= n; i++) {
      summe += 1. / i;
    }
    return summe;
  }
}
