package de.hdm_stuttgart.mi.sda1.exam.dataexport.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

/**
 * Representing a company's employees.
 */
@Entity
public class Department {

   @Id
   @Column(nullable=false)
   String shortname;// Cannot be "short" for obvious reasons.
   

   /**
    * @return A Department's abbreviated name e.g. "fs" representing
    *         "Financial Services".
    */
   public String getShort() {
      return shortname;
   }
   /**
    * @param shortname See {@link #getShort()}
    */
   public void setShort(String shortname) {
      this.shortname = shortname;
   }


   @Column(nullable=false)
   String name;
   /**
    * @return A Department's full name e.g. "Financial Services"
    */
   public String getName() {
      return name;
   }
   /**
    * @param name See {@link #getName()}
    */
   public void setName(String name) {
      this.name = name;
   }


   @ManyToOne()
   @JoinColumn(name="parent") // Prevent JPA from choosing "parent_short"
   Department parent;
   /**
    * @return A parent department if existing, null otherwise
    */
   public Department getParent() {
      return parent;
   }

   /**
    * @param parent See {@link #getParent()}
    */
   public void setParent(Department parent) {
      this.parent = parent;
   }
}