show tables;
show create TABLE FsObject;

DROP TABLE IF EXISTS FsObject;

CREATE TABLE FsObject (
  inode INT NOT NULL,
  PRIMARY KEY (inode),
  name VARCHAR(20) NOT NULL,
  parent INT NULL,
  FOREIGN KEY (parent) REFERENCES FsObject(inode),
  UNIQUE (parent, name),
  typ INT NOT NULL, /* 1=directory, 2 = file, 3 = symlink */
  target INT NULL,
  FOREIGN KEY (target) REFERENCES FsObject(inode)
);

INSERT INTO FsObject VALUES(
  100,   /* inode */
  "Dir_A",   /* Directory name */
  null,  /* No parent node (top level) */
  1,     /* Typ directory */
  null); /* No symlink */

INSERT INTO FsObject VALUES(
  101,   /* inode */
  "Dir_A_B", /* Directory name, subdir of "Dir_A" */
  100,   /* Parent directory "A" */
  1,     /* Typ directory */
  null); /* No symlink */

INSERT INTO FsObject VALUES(
  102,   /* inode */
  "File_A_test.txt", /* File in "Dir_A" */
  100,   /* Directory "A" */
  2,     /* Typ file */
  null); /* No symlink */

INSERT INTO FsObject VALUES(
  103,   /* inode */
  "Symlink_A_to_test.txt", /* File in "Dir_A" */
  100,   /* Directory "A" */
  2,     /* Typ file */
  null); /* No symlink */