package de.hdm_stuttgart.mi.sda1.impl;

import org.jdom2.Element;

import java.sql.ResultSet;
import java.sql.SQLException;

public class DbReadDuplicate extends DbRead {

  static private final String sqlQuery =
      "SELECT fullName, time, badStart\n" +
          "FROM Competition, Athlete\n" +
          "WHERE Competition.athlete = Athlete.id\n" +
          "ORDER BY time, fullName";

  public DbReadDuplicate() {
    super(sqlQuery);
  }

  @Override
  protected void insertRecord(final ResultSet result, final Element row, final int rank) throws SQLException {
    append(row, "td", "" + rank);
    append(row, "td", result.getString("fullName"));
    append(row, "td", result.getString("time"));

    if (result.getBoolean("badStart")) {
      row.setAttribute("style", "background: red;");
    }
  }
}
