package de.hdm_stuttgart.mi.sda1.sql2catalog;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import org.jdom2.Attribute;
import org.jdom2.Element;
import org.jdom2.Namespace;
import org.jdom2.output.Format;
import org.jdom2.output.XMLOutputter;

/**
 * A simple SAX parser demo
 * 
 */
public class Rdbms2Xml {

   /**
    * @param args Unused
    */
   public static void main(String[] args) {


      
      // Register Driver
      final String sqlDriverClassName = Messages.getString("Xml2Rdbms.jdbcDriverName"); 
      try {
         Class.forName(sqlDriverClassName);
      } catch (ClassNotFoundException e) {
         Helper.exitWithErrorMessage(Messages.getString("Xml2Rdbms.errMsgUnableRegisterDriverClass") + sqlDriverClassName + "'", 1);
      }

      // Opening a JDBC connection
      // 
      Connection conn = null;
      
      final String jdbcConnectionUrl = Messages.getString("Xml2Rdbms.jdbcUrl"); 
      final String userName = Messages.getString("Xml2Rdbms.jdbcUser"); 
      try {
         conn = DriverManager.getConnection(jdbcConnectionUrl, userName, Messages.getString("Xml2Rdbms.jdbcPasswd")); 
      } catch (SQLException e) {
         Helper.exitWithErrorMessage(Messages.getString("Xml2Rdbms.errMsgUnableToConnect") + userName + "' to '" + 
               jdbcConnectionUrl + "'", 1); 
      }
      RdbmsAccess rdbmsAccess = null;
      try {
         rdbmsAccess = new RdbmsAccess(conn);
      } catch (SQLException e) {
         Helper.exitWithErrorMessage(Messages.getString("Xml2Rdbms.errMsgUnableInitDataInsert"), 1); 
      }
      final Namespace xsiNS = Namespace.getNamespace("xsi", "http://www.w3.org/2001/XMLSchema-instance");
      final Element universityElement = new Element("university");
      final Attribute noNamespaceSchemaLocation = new Attribute("noNamespaceSchemaLocation", "university.xsd", xsiNS);
      universityElement.setAttribute(noNamespaceSchemaLocation);
      final Element studyCourses = new Element("studyCourses");
      universityElement.addContent(studyCourses);
      final Element students = new Element("students");
      universityElement.addContent(students);
      
      try {
         rdbmsAccess.appendStudyCourses(studyCourses);
         rdbmsAccess.appendStudents(students);
      } catch (SQLException e) {
         Helper.exitWithErrorMessage("Unable to read database:" + e.getLocalizedMessage(), 1);
      }
      
      // Write XML content to standard output
      XMLOutputter outputter = new XMLOutputter(Format.getPrettyFormat());
      try {
         outputter.output(universityElement, System.out);
      } catch (IOException e) {
         Helper.exitWithErrorMessage("Unable to write XML data:" + e.getLocalizedMessage(), 1);
      }
   }
}
