package de.hdm_stuttgart.mi.sda2.catalog.domain;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

/**
 * Supplier for products
 *
 */
@Entity  @SuppressWarnings("javadoc")
public class ProductProvider {

   @Id
   @GeneratedValue(strategy=GenerationType.IDENTITY)
   Long id;
   String name; // e.g. "Tennis racket"

   @OneToMany(mappedBy="primaryProvider", cascade=CascadeType.ALL)
   Set<Product> products;
   
   protected ProductProvider() {}
   
   public ProductProvider(String name) {
      products = new HashSet<Product>();
      setName(name);
   }

   public String getName() {
      return name;
   }

   public void setName(String name) {
      this.name = name;
   }

   public Long getId() {
      return id;
   }
   
   public void addProduct(final Product product) {
      if (!products.contains(product)) {
         ProductProvider pp = product.getPrimaryProvider();
         if (null != pp) {
            pp.products.remove(product);
         }
         product.setPrimaryProvider(this);
         products.add(product);
      }
   }
   
}
