package de.hdm_stuttgart.mi.sd1.address;

import static de.hdm_stuttgart.mi.sd1.address.model.Address.Column.FIRST_NAME;
import static de.hdm_stuttgart.mi.sd1.address.model.Address.Column.LAST_NAME;
import static de.hdm_stuttgart.mi.sd1.address.model.Address.Column.STREET;
import static de.hdm_stuttgart.mi.sd1.address.model.Address.Column.TEL;
import static de.hdm_stuttgart.mi.sd1.address.model.Address.Column.TOWN;
import static de.hdm_stuttgart.mi.sd1.address.model.Address.Column.ZIP;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.layout.StackPane;
import de.hdm_stuttgart.mi.sd1.address.model.Address;

public class AddressListScene extends Scene {

	final TableView<Address> addressTable = new TableView<Address>();

	final ObservableList<Address> personData = FXCollections
			.observableArrayList(new Address("Martin","Goik", "Nobelstr. 10", 70579, "Stuttgart", "0711 8923 2188"), 
								new Address("Jens","Hahn", "Nobelstr. 10", 70579, "Stuttgart", "0711 8923 2157"));

	final TableColumn<Address, String> firstNameCol = new TableColumn <Address, String>(FIRST_NAME.extern);
	final TableColumn<Address, String>  lastNameCol = new TableColumn <Address, String>(LAST_NAME.extern);
	final TableColumn<Address, String>  street = new TableColumn <Address, String>(STREET.extern);
	final TableColumn<Address, Integer>  zip = new TableColumn <Address, Integer>(ZIP.extern);
	final TableColumn<Address, String>  town = new TableColumn <Address, String>(TOWN.extern); 
	final TableColumn<Address, String>  tel = new TableColumn <Address, String>(TEL.extern);

	public AddressListScene(Main parent) {
		super(parent.root);

		firstNameCol.setCellValueFactory(new PropertyValueFactory<Address, String>(FIRST_NAME.intern));
		lastNameCol.setCellValueFactory(new PropertyValueFactory<Address, String>(LAST_NAME.intern));
		street.setCellValueFactory(new PropertyValueFactory<Address, String>(STREET.intern));
		zip.setCellValueFactory(new PropertyValueFactory<Address, Integer>(ZIP.intern));
		town.setCellValueFactory(new PropertyValueFactory<Address, String>(TOWN.intern));
		tel.setCellValueFactory(new PropertyValueFactory<Address, String>(TEL.intern));

		addressTable.setItems(personData);

		addressTable.getColumns().add(firstNameCol);
		addressTable.getColumns().add(lastNameCol);
		addressTable.getColumns().add(street);
		addressTable.getColumns().add(zip);
		addressTable.getColumns().add(town);
		addressTable.getColumns().add(tel);
		
		Button addAddress = new Button("Add address");
		addAddress.setOnAction(event -> {
			parent.addAddress();
		});
		
		
		StackPane basePane = new StackPane();
		basePane.getChildren().addAll(addressTable, addAddress);
		
		setRoot(basePane);
	}
	
	public void addAddress(final Address address) {
		personData.add(address);
	}
}
