package de.hdm_stuttgart.mi.sd1.address.model;

public class Address implements Comparable<Address> {
	public enum Column {

		FIRST_NAME("firstName", "First name")
		,LAST_NAME("lastName", "Last name")
		,STREET("street", "Street")
		,ZIP("zip", "Zip code")
		,TOWN("town", "Town")
		,TEL("lastName", "Last name")
		;

		Column(final String intern, final String extern) {
			this.intern = intern;
			this.extern = extern;
		}

		public final String
		intern,
		extern; // May become subject to internationalization
	}
	private String firstName;
	private String lastName;
	private String street;
	private int zip;
	private String town;
	private String tel;

	public Address(
			final String firstName,
			final String lastName,
			final String street,
			final int zip,
			final String town,
			final String tel) {
		setFirstName(firstName);
		setLastName(lastName);
		setStreet(street);
		setZip(zip);
		setTown(town);
		setTel(tel);
	}

	public String getFirstName() {
		return firstName;
	}

	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	public String getLastName() {
		return lastName;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	public String getStreet() {
		return street;
	}

	public void setStreet(String street) {
		this.street = street;
	}

	public int getZip() {
		return zip;
	}

	public void setZip(int zip) {
		this.zip = zip;
	}

	public String getTown() {
		return town;
	}

	public void setTown(String town) {
		this.town = town;
	}

	public String getTel() {
		return tel;
	}

	public void setTel(String tel) {
		this.tel = tel;
	}

	@Override
	public int compareTo(Address other) {
		return lastName.compareTo(other.lastName);
	}

}
