package de.hdm_stuttgart.mi.sd1.store;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertArrayEquals;

import org.junit.jupiter.api.Test;

import de.hdm_stuttgart.mi.sd1.statistics.IntegerStore;

@SuppressWarnings("javadoc")
public class TestSorting {

  @Test
  public void simpleSort() {
    final int[]
      unsortedValues = {0, -1, 5, 2, 7, 6},
      sortedValues = {-1, 0, 2, 5, 6, 7};

    assertEquals(sortedValues.length, unsortedValues.length);

    final IntegerStore store = new IntegerStore();
    for (final int i : unsortedValues) {
      store.addValue(i);
    }
    assertArrayEquals(sortedValues, store.getValues());
  }

  @Test
  public void duplicateSort() {
    final int[]
      unsortedValues = {0, -7, 3, 2, 3, -4, 3, 4, 5, -7},
      sortedValues = {-7, -7, -4, 0, 2, 3, 3, 3, 4, 5};

    assertEquals(sortedValues.length, unsortedValues.length);

    final IntegerStore store = new IntegerStore();
    for (final int i : unsortedValues) {
      store.addValue(i);
    }
    assertArrayEquals(sortedValues, store.getValues());
  }
}