package de.hdm_stuttgart.mi.sd1.connectfour;

import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.sd1.tictactoe.Helper;

/**
 * Testing Tic-tac-toe.
 */
public class HelperTest {
  
  @Test
  public void testOneField() {
    final int[] input = {9},
          result = Helper.excludeIndex(input, 0),
          expectedResult = {};
    
    Assert.assertArrayEquals(expectedResult, result);
  }

  @Test
  public void testTwoFields0() {
    final int[] input = {0, 8},
          result = Helper.excludeIndex(input, 0),
          expectedResult = {8};
    
    Assert.assertArrayEquals(expectedResult, result);
  }

  @Test
  public void testTwoFields1() {
    final int[] input = {0, 8},
          result = Helper.excludeIndex(input, 1),
          expectedResult = {0};
    
    Assert.assertArrayEquals(expectedResult, result);
  }

  @Test
  public void testArrayFields0() {
    final int[] input = {1,2,3},
          result = Helper.excludeIndex(input, 0),
          expectedResult = {2,3};
    
    Assert.assertArrayEquals(expectedResult, result);
  }

  @Test
  public void testArrayFields2() {
    final int[] input = {1,2,3},
          result = Helper.excludeIndex(input, 1),
          expectedResult = {1,3};
    
    Assert.assertArrayEquals(expectedResult, result);
  }

  @Test
  public void testThreeFields3() {
    final int[] input = {1,2,3},
          result = Helper.excludeIndex(input, 2),
          expectedResult = {1,2};
    
    Assert.assertArrayEquals(expectedResult, result);
  }
}