package de.hdm_stuttgart.mi.sd1.readfile;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

/**
 * Reading a text file and writing all content
 * to standard output
 */
public class ReadFile {

  /**
   * @param args unused
   */
  public static void main(String[] args) {
    final String inputFileName = "Testdata/input.txt"; // serving as a sample input file
    try {
      openStream(inputFileName);
    } catch (FileNotFoundException e) {
      System.err.println("File not found: " + inputFileName);
    } catch (IOException e) {
      System.err.println("Error reading file: " + inputFileName);
      System.err.println("Message was: " + e.getLocalizedMessage());
    }
  }

  /**
   * Trying to read a given filename or -path
   * 
   * @param inputFileName The intended file's pathname
   * @throws FileNotFoundException inputFileName does not exist
   * @throws IOException inputFileName cannot be read
   */
  public static void openStream(final String inputFileName) 
      throws FileNotFoundException, IOException {
    final FileReader fileReader = new FileReader(inputFileName);
    final BufferedReader inputBufferedReader = new BufferedReader(fileReader);
    readStream(inputBufferedReader);
  }

  static void readStream(final BufferedReader inputStream) throws IOException {
    int lineCounter = 1;
    for (String line = inputStream.readLine(); line != null; line = inputStream.readLine()) {
      System.out.println(lineCounter++ + ": " + line);
    }
  }
}