package de.hdm_stuttgart.mi.sd1.textstat;

import java.io.IOException;

/**
 * Reading a text file and creating the set of words being contained
 * among with their respective frequencies of appearance.
 */
public class TextStatistics {

  /**
   * @param fileNames counting word frequencies of this file name
   */
  public static void main(String[] fileNames) {

    TextFileHandler textFileHandler = null;

    if (1 == fileNames.length){ // Try to read from input file
      try {
        textFileHandler = new TextFileHandler(fileNames[0]);
      } catch (IOException e) {
        System.err.println("unable to read from file '" + fileNames[0] + "'");
        System.exit(1);
      }
    } else {
      System.err.println("I need exactly one file name argument");
      System.exit(1);
    }
    System.out.println("Unsorted frequencies:");
    textFileHandler.printFrequencies();
  }
}