package de.hdm_stuttgart.sd1.loop;

public class LoopExample {

  public static void main(String [] args) {
    
    final int upperLimit = 14;
    while_squareNumbers(upperLimit);
    doWhile_squareNumbers(upperLimit);
  }
  
  /**
   * Compute all square numbers starting from 4 in steps of 3
   * being smaller than a given limit. The results are being written to standard output.
   * Implemented by a while -loop.
   * 
   * @param limit An upper exclusive bound for the highest number to be squared..
   */
  public static void while_squareNumbers(final int limit) {
    System.out.println("Computing square numbers");
    int i = 4;
    while (i < limit) {
      System.out.println("i = " + i + ", i * i = " + i * i);
      i += 3;
    }
    System.out.println("Finished computing square numbers");
  }

  /**
   * Compute all square numbers starting from 4 in steps of 3
   * being smaller than a given limit. The results are being written to standard output.
   * Implemented by a do ... while -loop.
   * 
   * @param limit An upper exclusive bound for the highest number to be squared..
   */
  public static void doWhile_squareNumbers(final int limit) {
    System.out.println("Computing square numbers");
    int i = 4;
    if (i < limit) { // Needed !!!
      do {
        System.out.println("i = " + i + ", i * i = " + i * i);
        i += 3;
      } while (i < limit);
    }
    System.out.println("Finished computing square numbers");
  }
}