package de.hdm_stuttgart.sd1.math;

/**
 * Some class methods.
 */
public class Math {
  
  /**
   * Return the absolute value of a given argument
   * @param value The argument to be considered
   * @return the argument's absolute (positive) value.
   */
  public static double abs(double value) {
    if (value < 0) {
      return -value;
    } else {
      return value;
    }
  }
  
  /**
   * The maximum of two arguments
   * @param a First argument
   * @param b Second argument
   * @return The maximum of a and b
   */
  public static double max(double a, double b) {
    return a < b ? b : a; // very compact, avoiding "if". Readability??
  }
  
  /**
   * The maximum of three arguments
   * 
   * @param a First argument
   * @param b Second argument
   * @param c Third argument
   * @return The maximum of a, b and c
   */
  public static double max(double a, double b, double c) {
    final double max_A_B;
    if (a < b) {
      max_A_B = b;
    } else {
      max_A_B = a;
    }
    
    if (c < max_A_B) {
      return max_A_B;
    } else {
      return c;
    } 
  } 
}
