package de.hdm_stuttgart.sd1.rounding;

/**
 * Creating a math table providing sin values
 * in the range [0, 355] for every 5 degrees
 *
 */
public class MathTable {
   
   private final static int numberOfFractionDigits = 3; // Show this number of fractional digits

  /**
   * @param args unused
   */
  public static void main(String[] args) {

     int precision = 1;
     for (int i = 0; i < numberOfFractionDigits; i++) {
        precision *= 10;
     }
     
    System.out.println("  x | sin(x)");
    System.out.println("----+------");
    for (int i = 0; i < 360; i += 5) {
      
      final double
        sinValue = Math.sin(i * Math.PI / 180); // Turning degrees into radians
      
      final long
        // Rounding to the appropriate number of decimal places
        sinValueRounded = Math.round(precision *  sinValue);
      
      final double roundedValue = ((double)sinValueRounded) / precision; // double cast: avoid 223 / 1000 == 0
      
      final int totalNumberOfDigits = 3 + // Optional '-' + 1 digit + '.' + 
                                       numberOfFractionDigits;
      
      System.out.format(" %3d|%" + totalNumberOfDigits + "." + numberOfFractionDigits + "f %n", i, roundedValue);
      
      if (0 < i && 0 == i % 20) { // Add extra separator every four lines
        System.out.println("----+------");
      }
    }
  }
}