package de.hdm_stuttgart.mi.sda1.alignimg.handler;

public class Img {
   public final String imgUrl, alignmentValue;

   public Img(final String imgUrl, final String alignmentValue) {
      this.imgUrl = imgUrl;
      this.alignmentValue = alignmentValue;
   }

   @Override
   public int hashCode() {
      final int prime = 31;
      int result = 1;
      result = prime * result
            + ((alignmentValue == null) ? 0 : alignmentValue.hashCode());
      result = prime * result + ((imgUrl == null) ? 0 : imgUrl.hashCode());
      return result;
   }

   @Override
   public boolean equals(Object obj) {
      if (this == obj) {
         return true;
      } else if (obj instanceof Img) {
         final Img other = (Img) obj;
         if (alignmentValue == null) {
            if (other.alignmentValue != null)
               return false;
         } else if (!alignmentValue.equals(other.alignmentValue))
            return false;
         if (imgUrl == null) {
            if (other.imgUrl != null)
               return false;
         } else if (!imgUrl.equals(other.imgUrl)) {
            return false;
         }
         return true;
      } else {
         return false;
      }
   }

   @Override
   public String toString() {
      return "image element '" + imgUrl
               + "' having attribute align='" + alignmentValue + "'";
   }
   
   
}