package alignimg;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.junit.Assert;
import org.junit.Test;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

import de.hdm_stuttgart.mi.sda1.alignimg.handler.Img;
import de.hdm_stuttgart.mi.sda1.alignimg.handler.SaxErrorHandler;
import de.hdm_stuttgart.mi.sda1.alignimg.handler.SearchAlignContentHandler;

public class TestImgSearch {

   @Test
   public void searchAlignImageElements() throws ParserConfigurationException,
         SAXException, IOException {

      final SAXParserFactory saxPf = SAXParserFactory.newInstance();

      final SAXParser saxParser = saxPf.newSAXParser();
      final XMLReader xmlReader = saxParser.getXMLReader();

      xmlReader.setFeature("http://xml.org/sax/features/namespaces", true);
      xmlReader.setFeature("http://xml.org/sax/features/namespace-prefixes", true);

      final SearchAlignContentHandler searchAlignContentHandler = new SearchAlignContentHandler();
      xmlReader.setContentHandler(searchAlignContentHandler);
      xmlReader.setErrorHandler(new SaxErrorHandler());

      final String xmlDocumentInstanceFilename = "src/main/resources/testdata.xhtml";
      xmlReader.parse(xmlDocumentInstanceFilename);
      
      final Img[] expectedAlignImages = new Img[]{
            new Img("a.gif", "top")
           ,new Img("c.gif", "bottom")
      };
      // Image count correct?
      Assert.assertEquals(expectedAlignImages.length, searchAlignContentHandler.alignImages.size());
      
      // Images in list correct?
      for (int i = 0; i < expectedAlignImages.length; i++) {
         Assert.assertEquals(expectedAlignImages[i], searchAlignContentHandler.alignImages.get(i));
      }
   }
}