package de.hdm_stuttgart.mi.sda1.imgesearch.handler;

import java.util.Stack;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

public class SaxContentHandler implements ContentHandler {
   
   private static final Logger log = LogManager.getLogger(ContentHandler.class);
	
	int numberOfBlockLevelImgElements = 0,
			numberOfInlineImgElements = 0;
	
	final Stack<Boolean> parentIsContainerType = new Stack<Boolean>();

	public int getNumberOfBlockLevelImgElements() { return numberOfBlockLevelImgElements;}

	public int getNumberOfInlineImgElements() { return numberOfInlineImgElements;}

	@Override
	public void setDocumentLocator(Locator locator) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void startDocument() throws SAXException {
	   // Initialize variables which might still
	   //  carry values from a previous run.
		numberOfBlockLevelImgElements = numberOfInlineImgElements = 0;
		
	}

	@Override
	public void endDocument() throws SAXException {
		log.info("Finished: found " + numberOfBlockLevelImgElements
				+ " <img> elements");
		
	}

	@Override
	public void startPrefixMapping(String prefix, String uri)
			throws SAXException {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void endPrefixMapping(String prefix) throws SAXException {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void startElement(String uri, String localName, String qName,
			Attributes atts) throws SAXException {
		
		if (qName.equals("img")) {
			if (parentIsContainerType.peek()) {
				numberOfBlockLevelImgElements++;
			} else {
				numberOfInlineImgElements++;
			}
		}

		switch(qName) {
		
		case "body":
		case "div":
		case "th":
		case "td":
		parentIsContainerType.push(true);
		break;
		
		default:
	      parentIsContainerType.push(false);
		break;
		}
	}

	@Override
	public void endElement(String uri, String localName, String qName)
			throws SAXException {
      parentIsContainerType.pop();
	}

	@Override
	public void characters(char[] ch, int start, int length)
			throws SAXException {/* not yet needed */}

	@Override
	public void ignorableWhitespace(char[] ch, int start, int length)
			throws SAXException {/* not yet needed */}

	@Override
	public void processingInstruction(String target, String data)
			throws SAXException {/* not yet needed */}

	@Override
	public void skippedEntity(String name) throws SAXException {/* not yet needed */}
}