package de.hdm_stuttgart.mi.sda1.sql2catalog.model;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

import javax.persistence.CollectionTable;
import javax.persistence.Column;
import javax.persistence.ElementCollection;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OrderColumn;

@Entity
public class Product {

	protected Product() {}

	public Product(final int id, final String name, final Integer age) {
		setId(id);
		setName(name);
		setAge(age);
	}

	@Id
	int id;

	@Column(nullable = false)
	String name;

	Integer age;

	@ElementCollection
	@CollectionTable(name="Description", joinColumns={@JoinColumn(name="product")})
	@OrderColumn(name="orderIndex")
	List<Description> descriptions = new ArrayList<Description>();

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Optional<Integer> getAge() {
		return Optional.ofNullable(age);
	}

	public void setAge(Integer age) {
		this.age = age;
	}
	public List<Description> getDescriptions() {
		return descriptions;
	}
}
