package de.hdm_stuttgart.mi.persistence.test;

import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.persistence.PersistenceHandler;

/**
 * Opening and closing connections
 */
public class ConnectionTest {
   
   final ViewMockup viewMockup = new ViewMockup();

   final PersistenceHandler ph = new PersistenceHandler(viewMockup);

   /**
    */
   @Test
   public void openCloseConnection() {

      // Initially we should be in disconnected state
      Assert.assertFalse(ph.isConnected());
      
      // Connecting
      viewMockup.setStatusDisconnected();// Should be changed by subsequent call.
      ph.toggleConnectionState();
      Assert.assertTrue(viewMockup.connected);
      Assert.assertEquals("Connection to database established.", viewMockup.info);
      
      // Disconnecting
      ph.toggleConnectionState();
      
      Assert.assertFalse(viewMockup.connected);
      Assert.assertEquals("Connection to database closed.", viewMockup.info);
   }
}
