package de.hdm_stuttgart.mi.persistence;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * Reading database driver and connection properties.
 *
 */
public class DbProps {
   private static final String BUNDLE_NAME = "de.hdm_stuttgart.mi.database";

   private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle
         .getBundle(BUNDLE_NAME);

   /**
    * Retrieve parameter value
    * @param key The parameter's key string e.g. 
    *       "PersistenceHandler.jdbcUrl"
    * @return The parameter's value e.g.
    *    "jdbc:mysql://localhost:3306/hdm"
    */
   public static String getString(String key) {
      try {
         return RESOURCE_BUNDLE.getString(key);
      } catch (MissingResourceException e) {
         return '!' + key + '!';
      }
   }
}
