package de.hdm_stuttgart.mi.sda1.catalog2sql;

import java.io.IOException;
import java.io.PrintStream;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

import de.hdm_stuttgart.mi.sda1.catalog2sql.handler.CatalogContentHandler;
import de.hdm_stuttgart.mi.sda1.saxerrorhandler.handler.SaxErrorHandler;


/**
 * A simple SAX parser demo
 * 
 */
public class App {
    private static final Logger log = LogManager.getLogger(App.class);

    /**
     * @param args Unused
     * @throws SAXException 
     * @throws ParserConfigurationException 
     * @throws IOException 
     */
    public static void main( String[] args ) throws ParserConfigurationException, SAXException, IOException {
    	
    	log.info("Creating SAX parser");
    	final SAXParserFactory saxPf = SAXParserFactory.newInstance();
        final SAXParser saxParser = saxPf.newSAXParser();
        final XMLReader xmlReader = saxParser.getXMLReader();

        final PrintStream sqlOutputStream = new PrintStream("products.sql");
        final SqlFormatter sqlFormatter = new SqlFormatter(sqlOutputStream);
        
        log.info("Registering content- and error handler instances");
        xmlReader.setContentHandler(new CatalogContentHandler(sqlFormatter)); 
        xmlReader.setErrorHandler(new SaxErrorHandler(System.err));
        
        
        final String xmlDocumentInstanceFilename = "products.xml";
        log.info("Start parsing file '" + xmlDocumentInstanceFilename + "'");
        xmlReader.parse(xmlDocumentInstanceFilename);
        
        sqlOutputStream.close();
    }
}
