package de.hdm_stuttgart.mi.sda1.catalog2sax;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.apache.commons.io.FileUtils;
import org.junit.Assert;
import org.junit.Test;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

import de.hdm_stuttgart.mi.sda1.catalog2sql.SqlFormatter;
import de.hdm_stuttgart.mi.sda1.catalog2sql.handler.CatalogContentHandler;
import de.hdm_stuttgart.mi.sda1.saxerrorhandler.handler.SaxErrorHandler;

/**
 * Unit test comparing the converter's output to a given reference file.
 */
public class AppTest {
    /**
     * Dummy test method
     * @throws SAXException 
     * @throws IOException 
     * @throws ParserConfigurationException 
     */
    @Test
    public void testApp() throws IOException, SAXException, ParserConfigurationException {
    	
    	final SAXParserFactory saxPf = SAXParserFactory.newInstance();
        final SAXParser saxParser = saxPf.newSAXParser();
        final XMLReader xmlReader = saxParser.getXMLReader();

        final String sqlGeneratedFilename = "products.sql";
        
        final PrintStream sqlOutputStream = new PrintStream(sqlGeneratedFilename);
        final SqlFormatter sqlFormatter = new SqlFormatter(sqlOutputStream);
        
        xmlReader.setContentHandler(new CatalogContentHandler(sqlFormatter)); 
        xmlReader.setErrorHandler(new SaxErrorHandler(System.err));
        
        final String xmlDocumentInstanceFilename = "products.xml";
        xmlReader.parse(xmlDocumentInstanceFilename);
        
        sqlOutputStream.close();
    	final String referenceFilename = "src/test/products.reference.sql";    	
    	
        Assert.assertTrue( "Comparing '" + referenceFilename + "' and '" + sqlGeneratedFilename + "'",
        		FileUtils.contentEquals(new File(referenceFilename), new File(sqlGeneratedFilename)));
    }
}
