package de.hdm_stuttgart.mi.sda2.jpa.billing.domain;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;



/**
 * Credit card payment
 *
 */
@Entity
public class CreditCard extends BillingDetail {
   String cardCompany;
   
   @Column(nullable=false)
   @Temporal(TemporalType.DATE)
   Date expiry;
   
   
   protected CreditCard() {
      super();
   }
   
   @SuppressWarnings("javadoc")
   public CreditCard(final Customer customer, final String company) {
      super(customer);
      setCardCompany(company);
   }

   @SuppressWarnings("javadoc")
   public String getCardCompany() {
      return cardCompany;
   }

   @SuppressWarnings("javadoc")
   public void setCardCompany(String cardCompany) {
      this.cardCompany = cardCompany;
   }

   @SuppressWarnings("javadoc")
   public Date getExpiry() {
      return expiry;
   }

   @SuppressWarnings("javadoc")
   public void setExpiry(Date expiry) {
      this.expiry = expiry;
   }

   @Override
   public String toString() {
     
      return getCardCompany() + " credit card, expiry =" + getExpiry() + ", " + super.toString();
   } 
   
   
}
