DROP Table IF EXISTS SysUserGroup;
DROP Table IF EXISTS SysUser;
DROP Table IF EXISTS SysGroup;

CREATE TABLE  SysGroup (					-- The system's groups --
   id INTEGER AUTO_INCREMENT PRIMARY KEY
   ,gid CHAR(20) NOT NULL UNIQUE 			-- The groups unique name e.g. 'users' --
   ,gidNumber INTEGER NOT NULL UNIQUE 		-- The groups  unique numerical value e.g. 1332 --
);

CREATE TABLE SysUser (
   id INTEGER AUTO_INCREMENT PRIMARY KEY
   ,uid CHAR(20) NOT NULL UNIQUE 		-- The user's unique login name e.g. 'goik' --
   ,uidNumber INTEGER NOT NULL UNIQUE 	-- The user's unique uid number value--
   ,primaryGidNumber INTEGER NOT NULL	-- The user's primary group --
    	REFERENCES SysGroup 	
   ,cname VARCHAR(255)					-- The user's common name e.g. 'Martin Goik' --
   ,homeDirectory VARCHAR(255) NOT NULL -- The user's home directory e.g. '/home/goik' --
   ,shell VARCHAR(255) NOT NULL 		-- The user's login shell e.g. '/bin/bash' --	
);

CREATE TABLE SysUserGroup (
   sysuser INTEGER NOT NULL REFERENCES SysUser
   ,sysgroup INTEGER NOT NULL REFERENCES SysGroup
   ,PRIMARY KEY(sysuser, sysgroup)
);

