package de.hdm_stuttgart.mi.sd1.test.aufgabe2;

import de.hdm_stuttgart.mi.sd1.aufgabe2.Kreis;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;

/**
 * Teste Kreise.
 *
 */

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class TestKreis extends ExaminationTestDefaults {

  /**
   * (0,0, 4) enthält (0, 0, 3)
   * Konzentrische Kreise um Ursprung, größerer enthält kleineren.
   */
  @Test
  @Marking(points=1)
  public void test_100() {
    Assert.assertTrue(new Kreis(0,0,4).enthaelt(new Kreis(0,0,3)));
  }

  /**
   * (0,0, 3) enthält (0, 0, 4) nicht
   * Konzentrische Kreise um Ursprung, kleinerer enthält größeren nicht.
   */
  @Test
  @Marking(points=1)
  public void test_110() {
    Assert.assertTrue(new Kreis(0,0,4).enthaelt(new Kreis(0,0,3)));
  }

  /**
   * (4, 4, 3) enthält (5, 3, 1).
   */
  @Test
  @Marking(points=1)
  public void test_117() {
    Assert.assertTrue(new Kreis(4,-4,3).enthaelt(new Kreis(5,-3,1)));
  }
  /**
   * Gespiegelt: (4, 4, 3) enthält (5, 3, 1).
   */
  @Test
  @Marking(points=1)
  public void test_115() {
    Assert.assertTrue(new Kreis(4,4,3).enthaelt(new Kreis(5,3,1)));
  }

  /**
   * (4, 4, 3) schneidet (2, 6, 1).
   */
  @Test
  @Marking(points=1)
  public void test_120() {
    Assert.assertFalse(new Kreis(4,4,3).enthaelt(new Kreis(2,6,1)));
  }

  /**
   * Gespiegelt: (-4, -4, 3) schneidet (-2, -6, 1).
   */
  @Test
  @Marking(points=1)
  public void test_130() {
    Assert.assertFalse(new Kreis(-4,-4,3).enthaelt(new Kreis(-2,-6,1)));
  }
}