#set( $symbol_pound = '#' )
  #set( $symbol_dollar = '$' )
  #set( $symbol_escape = '\' )
  package ${package};

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import ${package}.model.Airline;

public class CreateAirline {

  static private final Logger log = LogManager.getLogger(CreateAirline.class);

  /**
   * This refers to a corresponding element <persistence-unit name = "strategy_drop-and-create" >
   * in META-INF/persistence.xml re-creating the relational database schema.
   */
  static public final String PERSISTENCE_UNIT_NAME = "strategy_drop-and-create";
  /**
   * @param args Unused
   */
  public static void main( String[] args ) {

    final EntityManagerFactory factory = Persistence.createEntityManagerFactory(PERSISTENCE_UNIT_NAME);
    final EntityManager em = factory.createEntityManager();

    log.info("Begin transaction");
    em.getTransaction().begin();
    final Airline lh = new Airline("Lufthansa", "DLH");

    em.persist(lh);
    em.getTransaction().commit();
    log.info("Committed transaction");

    em.close();

    // See http://stackoverflow.com/questions/21645516/program-using-hibernate-does-not-terminate
    factory.close();
  }
}