#set( $symbol_pound = '#' )
  #set( $symbol_dollar = '$' )
  #set( $symbol_escape = '\' )
  package ${package};

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;


import ${package}.model.Airline;
import ${package}.model.Airline_; // See comment further below.

public class SearchByIcao {
  static private final Logger log = LogManager.getLogger(SearchByIcao.class);

  /**
   * This refers to a corresponding element <persistence-unit name = "strategy_none" >
   * in META-INF/persistence.xml preserving the relational database schema.
   */
  static private final String PERSISTENCE_UNIT_NAME = "strategy_none";
  /**
   * @param args Unused
   */
  public static void main( String[] args ) {

    final EntityManagerFactory factory = Persistence.createEntityManagerFactory(PERSISTENCE_UNIT_NAME);
    final EntityManager em = factory.createEntityManager();
    final CriteriaBuilder cb = factory.getCriteriaBuilder();

    log.info("Read airlines by icao code");
    em.getTransaction().begin();

    final CriteriaQuery<Airline> criteria = cb.createQuery( Airline.class );
    final Root<Airline> airlineRoot = criteria.from( Airline.class );

    // Eclipse users note: The subsequent line of code requires "mvn generate-sources" or equivalent
    // triggering the metamodel generator. You may want to right click on your project root choosing
    //
    // "Run As" --> "Maven generate-sources".
    //
    // This step is being required whenever changes to your model classes in ${package}.model happen.

    criteria.where(cb.equal( airlineRoot.get( Airline_.icaoCode), "DLH" ));
    final List<Airline> airlines = em.createQuery( criteria ).getResultList();
    for (final Airline airline : airlines ) {
      System.out.println(airline);
    }
    em.getTransaction().commit();
    log.info("Read completed");

    em.close();

    factory.close();
  }
}