<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0"
    xmlns:db="http://docbook.org/ns/docbook"
    xmlns:xlink="http://www.w3.org/1999/xlink"
    xmlns="http://docbook.org/ns/docbook">
    
    <xsl:variable name="generateIdPrefix">__sdwordm4342cs__</xsl:variable>
    
    <xsl:output indent="no"/>
    
    <xsl:template match="@* | node()">
        <xsl:copy>
            <xsl:apply-templates select="@* | node()"/>
        </xsl:copy>
    </xsl:template>
    
    <xsl:template match="db:imagedata[substring-after(@fileref, '.') = 'fig']">
        <imagedata>
            <xsl:copy-of select="@*"/>
            <xsl:attribute name="fileref">
                <xsl:value-of select="@fileref"/>
                <xsl:text>.svg</xsl:text>
            </xsl:attribute>
        </imagedata>
    </xsl:template>
    
    <xsl:template match="db:mediaobject[db:videoobject]">
        
        <mediaobject>
            <xsl:copy-of select="@*"/>
            <imageobject>
                <imagedata scale="20">
                    <xsl:attribute name="fileref">
                        <xsl:value-of select="db:videoobject/db:videodata/@fileref"/>
                        <xsl:text>.png</xsl:text>
                    </xsl:attribute>
                </imagedata>
            </imageobject>            
            <xsl:variable name="onlineAvailabilityHint">Video available in the online version of this document.</xsl:variable>
            <xsl:choose>
                <xsl:when test="db:caption">
                    <xsl:for-each select="db:caption">
                        <caption>
                            <xsl:copy-of select="@* | node()"/>
                            <remark>
                                <xsl:value-of select="$onlineAvailabilityHint"/>
                            </remark>
                        </caption>
                    </xsl:for-each>
                </xsl:when>
                
                <xsl:otherwise>
                    <caption>
                        <remark>
                            <xsl:value-of select="$onlineAvailabilityHint"/>
                        </remark>
                    </caption>
                    
                </xsl:otherwise>
                
            </xsl:choose>
            
        </mediaobject>
        
    </xsl:template>
                
</xsl:stylesheet>
