package de.hdm_stuttgart.mi;

import org.junit.Assert;
import org.junit.Test;

/**
 * Unit test of {@link Check}.
 */
public class TargetDocTest {
    /**
     * anchor id="anton"
     */
    @Test
    public void testSimpleAnchor() {
        checkAnchorMatch("foo <a id=\"anton\"> <b>", "anton");
        checkAnchorMatch("foo <a ID  =\"anton\"> <b>", "anton");
        checkAnchorMismatch("foo <a id=\"anton\"> <b>", "anto");
        checkAnchorMismatch("foo <a id =\"anton\"> <b>", "anto");
    }
    /**
     * anchor id="indexOf(int)"
     */
    @Test
    public void testBraceAnchor() {
        checkAnchorMatch("foo <a id=\"indexOf(int)\"> <b>", "indexOf(int)");
        checkAnchorMismatch("foo <a id=\"indexOf(int)\"> <b>", "indexOf(in)");
    }

    /**
     * URL %20 encoded space and []
     */
    @Test
    public void testArrayBraceAnchor() {
        checkAnchorMatch("foo <a id=\"assertArrayEquals(int[], int[])\"> <b>",
            "assertArrayEquals(int[],%20int[])");
    }




    // Helper methods
    static void checkAnchorMatch(final String html, final String anchor) {
        Assert.assertTrue(html + " has no anchor " + anchor,
            TargetDoc.getAncorMatcher(anchor).matcher(html).find());
    }
    static void checkAnchorMismatch(final String html, final String anchor) {
        Assert.assertFalse(html + " should not have anchor " + anchor,
            TargetDoc.getAncorMatcher(anchor).matcher(html).find());
    }
}