package component.address;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 * Modify embedded content in a persistent {@link User} instance.
 *
 */
public class ModifyWorkAddress {

   /**
    * Retrieving a single {@link User} instance by means
    * of its primary key value two times in succession.
    * @param args unused
    */
   public static void main(String[] args) {
      
      
      final EntityManagerFactory factory = Persistence.createEntityManagerFactory("componentAddressPU");
      final EntityManager em = factory.createEntityManager();

      em.getTransaction().begin();
      {
         final User user = em.find(User.class, 1L);
         user.getWorkAddress().setStreet("100 Baker St");
      }
      em.getTransaction().commit();

      em.close();
      factory.close();
   }
}