package hibintro.v6;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

/**
 *         {@link Project} instances with surrogate primary key and composed business key
 */
@Entity
@Table(uniqueConstraints={@UniqueConstraint(columnNames={"name", "department"})})
public class Project {

  int id;

  @Id
  public int getId() { return id; }
  protected void setId(int id) { this.id = id; }

  String name;
  @Column(nullable=false)
  public String getName() { return name; }
  public void setName(String name) { this.name = name; }

  int department;
  @Column(nullable=false)
  public int getDepartment() { return department; }
  public void setDepartment(int department) { this.department = department; }
  
  protected Project() {}
  
  public Project(String name, int department) {
    setName(name);
    setDepartment(department);
  }
}