package inherit.v3;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

/**
 * Retrieval of all {@link Circle} objects from a database.
 */
public class RetrieveAll {

  /**
   * @param args unused
   */
  public static void main(String[] args) {
     final EntityManagerFactory factory = Persistence.createEntityManagerFactory("inheritV3PU");
     final EntityManager em = factory.createEntityManager();

     em.getTransaction().begin();
     {
        final TypedQuery<Figure> searchFigures = em.createQuery("from Figure", Figure.class);

        for (final Figure f: searchFigures.getResultList()) {
          System.out.println(f);
        }
     }
     em.getTransaction().commit();

     em.close();
     factory.close();
  }
}