package dom.xsl;

/**
 * Invoking the xml to html conversion application
 * 
 * @author goik
 *
 */
public class Xml2HtmlDriver {
  /**
   * @param args Unused
   */
  public static void main(String[] args) {
    final String 
    	inFilename = "Input/Dom/climbing.xml",
    	xslFilename = "Input/Dom/catalog2html.xsl", 
    	htmlOutputFilename = "Input/Dom/climbing.html";
    try {
      final Xml2Html converter = new Xml2Html(xslFilename);
      converter.transform(inFilename, htmlOutputFilename);
    } catch (Exception e) {
      System.err.println("The conversion of '" + inFilename
          + "' by stylesheet '" + xslFilename
          + "' to output HTML file '" + htmlOutputFilename
          + "' failed with the following error:" + e);
      e.printStackTrace();
    }
  }
}