package sax.stat.v2;

import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;

/** @see sax.stat.v1.MyEventHandler */
public class MyEventHandler extends DefaultHandler {

  /** @see sax.stat.v1.MyEventHandler#startDocument() */
  public void startDocument() {
    System.out.println("Opening Document");
  }
  /** @see sax.stat.v1.MyEventHandler#endDocument() */
  public void endDocument() {
    System.out.println("Closing Document");
  }
  /** @see sax.stat.v1.MyEventHandler#startElement(
   * String, String, String, Attributes) */
  public void startElement(String namespaceUri, String localName,
      String rawName, Attributes attrs) {
    System.out.println("Opening \"" + rawName + "\"");
    elementCount++;
  }
  /** @see sax.stat.v1.MyEventHandler#endElement(
   * String, String, String) */
  public void endElement(String namespaceUri, String localName,
      String rawName) {
    System.out.println("Closing \"" + rawName + "\"");
  }
  /** @see sax.stat.v1.MyEventHandler#characters(char[], int, int) */
  public void characters(char[] ch, int start, int length) {
    System.out.println("Content \"" + new String(ch, start, length)
        + '"');
  }
  /**
   * @return See {@link sax.stat.v1.MyEventHandler#getElementCount()}
   * */
  public int getElementCount() {
    return elementCount;
  }
  private int elementCount = 0;
}