package party1;

/**
 * Implementing party statistics by an explicit formula.
 *
 */
public class PartyStatisticsImpl implements PartyStatistics {
    
    @Override
    public void setNumberOfGuests(int numGuests) { this.numGuests = numGuests;}

    @Override
    public void setNumberOfOrganizers(int numOrganizers) { this.numOrganizers = numOrganizers;}

    @Override
    public void setExpenses(float expenses) { this.expenses = expenses;}

    @Override
    public float getAverageExpenses() {
        return expenses / numOrganizers;
    }
    @Override
    public int getNumberOfHandshakes() {
        final int totalPersonsNum = numGuests + numOrganizers;
        return totalPersonsNum * (totalPersonsNum - 1) / 2;
    }
    
    int numGuests = 0;  
    int numOrganizers = 0;
    float expenses = 0f;
}