package xml2rdbms.solution;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Properties;

/**
 * Handling relational data. So far connection information is yet
 * hard coded and needs further enhancements by e.g. 
 * {@link Properties}.
 *
 */
public class DatabaseAccess {
	
	static { // One time driver registration
		try {
			Class.forName("com.mysql.jdbc.Driver");
		} catch (ClassNotFoundException e1) {
			System.err.println("Unable to register JDBC driver");
		}
	}

	private Connection conn;
	private Statement stmt;
	
	
	/**
	 * Open a connection to a hard wired RDBMS data source.
	 */
	public void connect() {
		try {
			conn = DriverManager.getConnection(
					 "jdbc:mysql://localhost:3306/hdm", "hdmuser", "XYZ");
			try {
				stmt = conn.createStatement();
			} catch (SQLException e) {
				System.err.println("Unable to create statement");
			}
		} catch (SQLException e) {
			System.err.println("Unable to connect to database server");
		}
	}
	/**
	 * Closing an existing database connection
	 */
	public void close() {
		try {
			conn.close();
		} catch (SQLException e) {
			System.err.println("Unable to close connection");
		}
	}
	/**
	 * Insert a single data set.
	 * 
	 * @param transactionId The current transaction ID
	 * @param partNum    The part's article number 
	 * @param quantity The part's quantity
	 * @param comment Helpful information describing the current transaction
	 */
	public void insert(final int transactionId, final String partNum, final int quantity, 
			final String comment) {
		
		final String insertStmt;
		if (null == comment) {
			insertStmt = "INSERT INTO Billing VALUES(" + transactionId
					 + ", '" + partNum + "', " + quantity + ",  NULL)";
		} else {
			insertStmt = "INSERT INTO Billing VALUES(" + transactionId
					 + ", '" + partNum + "', " + quantity + ", '" + comment + "')";
		}
		
		try {
			stmt.executeUpdate(insertStmt);
		} catch (SQLException e) {
			System.err.println("Unable to insert dataset:" + e.getLocalizedMessage());
		}
	}
	
}
